//Create HUD elements
rezbarv2Init()
{
	self.rezbarv2 = [];
	self.rezbarv2state = true; //enabled
	
	if(!isDefined(self.rezbarv2["overlay_small"]))
	{
		self.rezbarv2["overlay_small"] = newClientHUDElem(self);
		self.rezbarv2["overlay_small"].x = 8;
		self.rezbarv2["overlay_small"].y = 60;
		self.rezbarv2["overlay_small"].alignX = "left";
		self.rezbarv2["overlay_small"].alignY = "top";
		self.rezbarv2["overlay_small"].horzAlign = "left";
		self.rezbarv2["overlay_small"].vertAlign = "top";
		self.rezbarv2["overlay_small"].alpha = 0.7;
		self.rezbarv2["overlay_small"].sort = 12000;
		self.rezbarv2["overlay_small"] setshader("black", 300, 20);
	}
	
	if(!isDefined(self.rezbarv2["overlay_big"]))
	{
		self.rezbarv2["overlay_big"] = newClientHUDElem(self);
		self.rezbarv2["overlay_big"].x = 8;
		self.rezbarv2["overlay_big"].y = 80;
		self.rezbarv2["overlay_big"].alignX = "left";
		self.rezbarv2["overlay_big"].alignY = "top";
		self.rezbarv2["overlay_big"].horzAlign = "left";
		self.rezbarv2["overlay_big"].vertAlign = "top";
		self.rezbarv2["overlay_big"].alpha = 0;
		self.rezbarv2["overlay_big"].sort = 12000;
		self.rezbarv2["overlay_big"] setshader("black", 300, 1);
	}
	
	if(!isDefined(self.rezbarv2["status"]))
	{
		self.rezbarv2["status"] = newClientHUDElem(self);
		self.rezbarv2["status"].x = 12;
		self.rezbarv2["status"].y = 65;
		self.rezbarv2["status"].alignX = "left";
		self.rezbarv2["status"].alignY = "top";
		self.rezbarv2["status"].horzAlign = "left";
		self.rezbarv2["status"].vertAlign = "top";
		self.rezbarv2["status"].alpha = 0;
		self.rezbarv2["status"].sort = 12001;
	}
	
	if(!isDefined(self.rezbarv2["load_bar"]))
	{
		self.rezbarv2["load_bar"] = newClientHUDElem(self);
		self.rezbarv2["load_bar"].x = 8;
		self.rezbarv2["load_bar"].y = 80;
		self.rezbarv2["load_bar"].alignX = "left";
		self.rezbarv2["load_bar"].alignY = "top";
		self.rezbarv2["load_bar"].horzAlign = "left";
		self.rezbarv2["load_bar"].vertAlign = "top";
		self.rezbarv2["load_bar"].alpha = 0;
		self.rezbarv2["load_bar"].sort = 12002;
		self.rezbarv2["load_bar"] setshader("white", 1, 1);
	}
	
	if(!isDefined(self.rezbarv2["overlay_hint"]))
	{
		self.rezbarv2["overlay_hint"] = newClientHUDElem(self);
		self.rezbarv2["overlay_hint"].x = self.rezbarv2["overlay_small"].x;
		self.rezbarv2["overlay_hint"].y = self.rezbarv2["overlay_small"].y - 8;
		self.rezbarv2["overlay_hint"].alignX = "left";
		self.rezbarv2["overlay_hint"].alignY = "top";
		self.rezbarv2["overlay_hint"].horzAlign = "left";
		self.rezbarv2["overlay_hint"].vertAlign = "top";
		self.rezbarv2["overlay_hint"].fontScale = 0.7;
		self.rezbarv2["overlay_hint"].alpha = 0.5;
		self.rezbarv2["overlay_hint"].sort = 12010;
		self.rezbarv2["overlay_hint"] setText(&"RZLPIER2_REZBAR_HINT");
	}
}
rezbarv2MonitorUserKeys()
{
	playerWait = 0;
	totalWait = 0.5;
	frame = 0.05;
	use_pressed = false;
	objectives_exec = false; 
	
	while(true)
	{
		if(self.rezbarv2state)
		{
			if(self usebuttonpressed())
				use_pressed = true;
			else if(use_pressed)
			{
				objectives_exec = false;
				use_pressed = false;
			}
			
			if(use_pressed)
			{
				if(playerWait>=totalWait)
				{
					if(isDefined(self.addingObjective) && !self.addingObjective && !objectives_exec)
					{
						objectives_exec = true;
						
						if(!isDefined(self.rezbarv2["objective_lines"]))
							rezbarv2ShowObjectives();
						else rezbarv2HideObjectives();
					}
				} else playerWait += frame;
			} 
			else if(playerWait!=0)
				playerWait = 0;
		}
		wait frame;
	}
}
rezbarv2SetEnabled(enabled)
{
	self.rezbarv2state = enabled;
	if(isDefined(self.rezbarv2["objective_lines"]))
		rezbarv2HideObjectives();
	
	
	if(self.rezbarv2state) 
	{
		self.rezbarv2["overlay_small"].alpha = 0.7;
		self.rezbarv2["overlay_hint"].alpha = 0.7;
	}
	else
	{
		self.rezbarv2["overlay_small"].alpha = 0;
		self.rezbarv2["status"].alpha = 0;
		self.rezbarv2["overlay_big"].alpha = 0;
		self.rezbarv2["load_bar"].alpha = 0;
		self.rezbarv2["overlay_hint"].alpha = 0;
	}
}
rezbarv2Load(time, idle_time)
{
	self.rezbarv2["load_bar"].alpha = 1;
	self.rezbarv2["load_bar"] scaleOverTime(time, 300, 1);
	wait time+idle_time;
	self.rezbarv2["load_bar"].alpha = 0;
	self.rezbarv2["load_bar"] setshader("white", 1, 1);
}
rezbarv2Notify(localized_string, local_sound, persistent)
{
	self playLocalSound(local_sound);
	self.rezbarv2["status"] setText(localized_string);
	self.rezbarv2["status"].alpha = 1;
	if(!persistent)
	{
		self.rezbarv2["status"] fadeOverTime(2);
		self.rezbarv2["status"].alpha = 0;
	}
}
rezbarv2NotifySimple(localized_string)
{
	rezbarv2Notify(localized_string, "rezbarv2_notif", false);
}
rezbarv2ShowObjectives()
{
	self.rezbarv2["overlay_big"].alpha = 0.5;
	count = getActiveObjectiveCount();
	if(count<=0)
	{
		self iprintlnbold(&"RZLPIER2_OBJ_NO_ACTIVE_OBJECTIVES");
		return;
	}
	else
	{
		self.rezbarv2["overlay_big"] scaleOverTime(count/10, 300, 20*count);
		wait count/10 + 0.1;
		self objectivePopulateHud();
	}
}
rezbarv2HideObjectives()
{
	self objectiveRemoveHudText();
	
	count = getActiveObjectiveCount();
	if(count <=0) count = 1;
	
	if(isDefined(self.rezbarv2["overlay_big"]))
		self.rezbarv2["overlay_big"] scaleOverTime(count/10, 300, 1);
		
	wait count/10 + 0.1;
	
	if(isDefined(self.rezbarv2["overlay_big"]))
		self.rezbarv2["overlay_big"].alpha = 0;
}
//called when an objective is either added or removed, if the obj screen is open it will be
//re-scaled and the objective text added
rezbarv2UpdateObjectiveScreen(deleted)
{
	if(isDefined(self.rezbarv2["objective_lines"]))
	{
		count = getActiveObjectiveCount();
		if(count<=0) 
		{
			rezbarv2HideObjectives(); //we know lines are defined, but we have 0 lines, so just hide everything
			return;
		}
		if(deleted) //if el deleted, first repopulate, then scale screen
		{
			objectivePopulateHud();
			self.rezbarv2["overlay_big"] scaleOverTime(0.2, 300, 20*count);
			wait 0.3;
		}
		else //first scale screen, then add el
		{
			self.rezbarv2["overlay_big"] scaleOverTime(0.2, 300, 20*count);
			wait 0.3;
			objectivePopulateHud();
		}
	}
}
//objective code here
objectivePopulateHud()
{
	//init should be called before this func
	if(isDefined(self.rezbarv2["objective_lines"]))
		objectiveRemoveHudText();
	
	
	self.rezbarv2["objective_lines"] = [];
	index = 0;
	
	for(i=0;i<self.rez["objective"].length;i++)
	{
		//only display active defined objectives
		if(isDefined(self.rez["objective"].el[i]) && self.rez["objective"].state[i]=="active")
		{
			self.rezbarv2["objective_lines"][i] = newClientHudElem(self);
			self.rezbarv2["objective_lines"][i].x = self.rezbarv2["overlay_big"].x + 4;
			self.rezbarv2["objective_lines"][i].y = self.rezbarv2["overlay_big"].y + 2 + 20*index;
			self.rezbarv2["objective_lines"][i].alignX = "left";
			self.rezbarv2["objective_lines"][i].alignY = "top";
			self.rezbarv2["objective_lines"][i].horzAlign = "left";
			self.rezbarv2["objective_lines"][i].vertAlign = "top";
			self.rezbarv2["objective_lines"][i].alpha = 1;
			self.rezbarv2["objective_lines"][i].sort = 12100;
			self.rezbarv2["objective_lines"][i].fontScale = 1.2;	
			self.rezbarv2["objective_lines"][i] setText(self.rez["objective"].label[i]);
			
			index++;
		}
	}
}
objectiveRemoveHudText()
{
	if(isDefined(self.rezbarv2["objective_lines"]))
	{
		for(i=0;i<self.rez["objective"].length;i++)
		{
			if(isDefined(self.rezbarv2["objective_lines"][i]))
			{
				self.rezbarv2["objective_lines"][i] destroy();
				self.rezbarv2["objective_lines"][i] = undefined;
			}
		}
		self.rezbarv2["objective_lines"] = undefined;
	}
}
getActiveObjectiveCount()
{
	if(!isDefined(self.rez["objective"]))
		return -1;
	
	count = 0;
	
	for(i=0;i<self.rez["objective"].length;i++)
		if(isDefined(self.rez["objective"].el[i]) && self.rez["objective"].state[i]=="active")
			count++;
	return count;
}
objectiveInit()
{
	if(!isDefined(self.rez))
		self.rez = [];
	if(!isdefined(self.rez["objective"]))
	{
		self.rez["objective"] = spawnStruct();
		self.rez["objective"].el = [];
		self.rez["objective"].state = [];
		self.rez["objective"].label = [];
		self.rez["objective"].length = 0;
		wait 0.05;
	}
}
isValidState(state)
{
	switch(state)
	{
		case "empty":
		case "active":
		case "invisible":
		case "done":
		case "current":
		case "failed":
			return true;
		default:
			return false;
	}
}
objectiveDelete(index)
{
	if(isDefined(self.rez["objective"].el[index]))
	{
		self.rez["objective"].el[index] destroy();
		self.rez["objective"].el[index] = undefined;
		self.rez["objective"].state[index] = undefined;
		self.rez["objective"].label[index] = undefined;
		
		self rezbarv2UpdateObjectiveScreen(true); //update if screen is open
	}
}
objectiveDeleteAll(index)
{
	p = getEntArray("player", "classname");
	
	for(i=0;i<p.size;i++)
		p[i] objectiveDelete(index);
}
objectiveGetState(index)
{
	if(isDefined(self.rez["objective"].el[index]))
		return self.rez["objective"].state[index];
}
objectiveSetState(index, state)
{
	if(isDefined(self.rez["objective"].el[index])) //if it's defined, the state for it should be defined too.
	{
		if(isValidState(state)) self.rez["objective"].state = state;
		else self.rez["objective"].state = "done";
	}
}
objectiveIcon(index, shader)
{
	if(isDefined(self.rez["objective"].el[index])) //if it's defined, the state for it should be defined too.
		self.rez["objective"].el[index] setShader(shader, 16, 16);
}
objectiveAdd(index, state, origin, shader, label)
{
	cg_hudcompass_scale = 1; //will have to force the player compass scale at some point in future
	scale = 45; //yields best results imho
	compass_center = [];
	compass_center[0] = 60 * cg_hudcompass_scale;
	compass_center[1] = -60 * cg_hudcompass_scale; //-60 because alignment is 'bottom'
	
	if(!isDefined(self.addingObjective))
		self.addingObjective = false;
	
	self.addingObjective = true;
	
	if(self.rez["objective"].length<=index)
		self.rez["objective"].length = index+1; //keep track of max because of variable length arrays
	
	if(!isValidState(state))
		state = "done";
	else self.rez["objective"].state[index] = state;
	
	self.rez["objective"].label[index] = label;
	
	if(!isDefined(self.rez["objective"].el[index]))
	{
		self.rez["objective"].el[index] = newClientHUDElem(self);
		
		if(!isDefined(origin))
		{
			self rezbarv2UpdateObjectiveScreen(false); //update screen anyway
			self.addingObjective = false;
			return; //only make a blank HUD element(so our isDefined checks at other locations still work)
		}
		
		self.rez["objective"].el[index].alignX = "center";
		self.rez["objective"].el[index].alignY = "middle";
		self.rez["objective"].el[index].horzAlign = "left";
		self.rez["objective"].el[index].vertAlign = "bottom";
		self.rez["objective"].el[index].x = compass_center[0]; 
		self.rez["objective"].el[index].y = compass_center[1]; 
		self.rez["objective"].el[index].foreground = 1;
		self.rez["objective"].el[index].alpha = 0;
		self.rez["objective"].el[index] setshader(shader, 16, 16);
	}
	if(isDefined(self.rez["objective"].state[index]))
		_rez_obj_update(index, origin, compass_center, scale); //called to set x and y of hud elem
	wait 0.05;
	self thread _rez_obj_monitor_user(index, origin, compass_center, scale);
	
	self rezbarv2UpdateObjectiveScreen(false); //update if screen is open
	self.addingObjective = false;
}
_rez_obj_monitor_user(index, obj_origin, center, scale)
{
	position = self getOrigin();
	angles = self getPlayerAngles();
	
	while(isDefined(self.rez["objective"].state[index]))
	{
		if(position!=self getOrigin() || angles!=self getPlayerAngles())
		{
			position = self getOrigin();
			angles = self getPlayerAngles();
			_rez_obj_update(index, obj_origin, center, scale);
		}
		wait 0.05;
	}
}
_rez_obj_update(index, origin, center, scale)
{
	r_x = get2dDistance(self getOrigin()[0], origin[0]);
	r_y = get2dDistance(self getOrigin()[1], origin[1]);
	tmp = (r_x*r_x)+(r_y*r_y);
	r = rezSqrt(tmp, 20);
	
	a_angle = acos(r_y/r)+self getPlayerAngles()[1]-90; //-90 to offset properly
	s_angle = asin(r_x/r)+self getPlayerAngles()[1]-90; //-90 to offset properly
	
		
	if(r_y<0 && r_x<0) 
	{
		a_angle = acos((-1*r_x)/r)-90-self getPlayerAngles()[1]; //the only quadrant that
		s_angle = asin((-1*r_y)/r)-90-self getPlayerAngles()[1]; //needed fucking special adjustments
		if(r>2000) r = 2000;
		
		x = r*cos(a_angle)/scale;
		y = r*sin(s_angle)/scale;
	}
	else if(r_y>0 && r_x<0) 
	{
		if(r>2000) r = 2000;
		x = r*sin(s_angle)/scale;
		y = r*cos(s_angle)/scale;
	}
	else if(r_y<0 && r_x>0) 
	{
		if(r>2000) r = 2000;
		x = r*sin(a_angle)/scale;
		y = r*cos(a_angle)/scale;
	}
	else
	{
		if(r>2000) r = 2000;
		x = r*sin(a_angle)/scale;
		y = r*cos(a_angle)/scale;
	}
	
	if(isdefined(self.rez["objective"].el[index]))
	{
		//self.rez["objective"].el[index] moveOverTime(0.05);
		if((center[0]+x)>105)
			self.rez["objective"].el[index].x = 105;
		else if((center[0]+x)<15)
			self.rez["objective"].el[index].x = 15;
		else self.rez["objective"].el[index].x = center[0]+x;
		
		if((center[1]-y)<-105)
			self.rez["objective"].el[index].y = -105;
		else if((center[1]-y)>-15)
			self.rez["objective"].el[index].y = -15;
		else self.rez["objective"].el[index].y = center[1]-y;
		
		setObjectiveVisibility(index);
	}
}
setObjectiveVisibility(index)
{
	if(self.rezbarv2state || !self.isInCinematic)
	{
		if(isAlive(self))
			self.rez["objective"].el[index].alpha = 1;
		else self.rez["objective"].el[index].alpha = 0;
	} else self.rez["objective"].el[index].alpha = 0;
}
objectiveVis()
{
	for(i=0;i<self.rez["objective"].length;i++)
	{
		if(isDefined(self.rez["objective"].el[i]))
			setObjectiveVisibility(i);
	}
}

get2dDistance(point1, point2)
{
	return (point2-point1);
}
rezSqrt(n, loops)
{
	result = 0;
	result = _m_sqrt(n, 1, loops, 0);
	return result;
}
rezAbs(a)
{
	if(a>0)
		return a;
	else return a*-1;
}
_m_sqrt(n, x, loops, counter)
{
	if(loops==counter)
		return x;
	else 
	{
		x = (x+(n/x))/2;
		x = _m_sqrt(n, x, loops, counter+1);
		return x;
	}
}