#include maps\mp\_utility;
#include maps\mp\_pier2_functions;
#include maps\mp\_pier2_objectives;
#include maps\mp\_pier2_music_manager;
#include maps\mp\_pier2_vo;

//#include maps\mp\_pier2_rezphone; 
/*
------------------------------------------------------------------------------
---------------------Scripted by: Rezil---------------------------------------
------------------------------------------------------------------------------
---------------------Contact detail:------------------------------------------
------------------------------------------------------------------------------
---------------------xfire: saberteeth----------------------------------------
---------------------e-mail: rezil337@gmail.com-------------------------------
------------------------------------------------------------------------------
---------------------If you have any questions, add me on xfire or------------
---------------------send me en e-mail.---------------------------------------
------------------------------------------------------------------------------
---------------------Level code for jm_pier_2---------------------------------
------------------------------------------------------------------------------
*/

main()
{
	maps\mp\_pier2_precaches::precache();
	maps\mp\_load::main();
	maps\mp\jm_pier_2_fx::main();
	maps\mp\_lockpicking::load();
	vo_load();
	
	setExpFog(.0001, 5/255, 15/255, 24/255, 0);
	//setCullFog(0, 13000, 5/255, 15/255, 24/255, 0);
	
	game["allies"] = "british";
	game["axis"] = "german";
	game["attackers"] = "allies";
	game["defenders"] = "axis";
	game["british_soldiertype"] = "africa";
	game["german_soldiertype"] = "africa";
	
	ambientPlay("ambient_pier2");
	
	level.german_xmodel = "xmodel/playerbody_german_africa01";
	level.german_xmodel_head = "xmodel/head_german_afrca_josh";
	level.american_xmodel = "xmodel/playerbody_british_africa01";;         
	level.american_xmodel_head = "xmodel/head_british_joel";
	precacheModel(level.american_xmodel);
	precacheModel(level.american_xmodel_head);
	precacheModel(level.german_xmodel);
	precacheModel(level.german_xmodel_head);
	
	level.has_handle = false;
	level.minibridge_lengthened = false;
	level.bridge_raised = false;
	level.bridge_lifting = false;
	level.boatyard_generator_on = false;
	level.speeder_dropped = false;
	level.walkway_destroyed = false;
	level.bed_moved = false;
	
	level.end_elevator_location = false; //TOP: true, BOTTOM: false
	level.end_elevator_moving = false; //moving thing
	
	level.TERMINALS_COUNT = 3; //Update this when you create multiple triggers
	level.TOOL_COUNT = 4;
	level.SECRET_AMMOUNT = 5;
	//------------------------------------------
	setupRandomizedSecrets();
	
	thread pier2_init_before_pspawn(); //put stuff here to set before players start playing
	thread pier2_on_player_connect();
	thread pier2_intro_trigger();
	thread pier2_drowning_kill();
	thread pier2_minibridge_part();
	thread pier2_minibridge_handle_pickup();
	thread pier2_small_dock_doors();
	thread pier2_soundThread();
	for(i=0;i<level.TERMINALS_COUNT;i++)
		thread terminalTrigger(i);
	for(i=0;i<level.TOOL_COUNT;i++)
		thread pickupTool(i);
		
	thread pier2_battery_fix();
	thread pier2_generator3_trig();
	thread pier2_bridge_control_door();
	thread pier2_bridge_shortcut_fix();
	thread pier2_cogs_bridge_control();
	thread pier2_admin_door_left();
	thread pier2_admin_door_right();
	thread pier2_warehouse4_bomb_sequence();
	thread pier2_storage_stuff();
	thread pier2_wires_killthread();
	thread pier2_ship_drop_trig();
	thread pier2_ship_container_exit();
	
	thread pier2_walkway_sequence();
	thread pier2_lockpicks();
	thread pier2_plants_photographing();
	
	thread pier2_boatyard_office_cog();
	thread pier2_boatyard_generator_insert_trig();
	thread pier2_boatyard_office_door();
	thread pier2_boatyard_entrance();
	thread pier2_boatyard_fence_ledge();
	
	thread pier2_electric_wire_loop();
	thread pier2_after_walkway_trig();
	thread pier2_bunker_trig();
	
	thread pier2_speeder_key();
	thread pier2_speeder_fuel();
	
	thread pier2_mansion_sliding_doors();
	thread pier2_mansion_pic_trig();
	
	thread pier2_end_elevator_btn("pier2_end_gallery_elevator_top_btn", true);
	thread pier2_end_elevator_btn("pier2_end_gallery_elevator_bottom_btn", false);
	thread pier2_end_elevator_inside_ele_trig();
	thread pier2_end_elevator_killtrig();
	thread pier2_end_elevator_key();
	thread pier2_end_lounge_door("pier2_end_lounge_enter", "pier2_end_lounge_enter_org");
	thread pier2_end_lounge_door("pier2_end_lounge_exit", "pier2_end_lounge_exit_org");
	thread pier2_end_lounge_musicbox();
	
	thread pier2_end_lounge_door("pier2_skyscraper_godown_trig", "pier2_skyscraper_godown_org");
	
	thread pier2_crane_top_ambient();
	
	thread pier2_ticket_office_voice_trig();
	thread pier2_admin_office_vo_trig();
	thread pier2_weap_storage_vo_trig();
	thread pier2_wire_cross_vo_trig();
	
	thread pier2_easteregg_dukemode_trig();
	thread pier2_easteregg_skyscraper_enter();
	
	//Warehouse 1 entrance
	thread pier2_vo_single_line_setup("pier2_w1_voice_trig", "warehouse1", 0.5, 
									  "pier2vo_john_way_to_roof", &"PIER2VO_JOHN_WAY_TO_ROOF", 2.5);
	//Warehouse 3 roof entrance
	thread pier2_vo_single_line_setup("pier2_w3_voice_trig", "warehouse3", 1, 
									  "pier2vo_john_where_the_hell_is_croom", &"PIER2VO_JOHN_WHERE_THE_HELL_IS_CROOM", 4.5);
	//After minibridge is extended
	thread pier2_vo_single_line_setup("pier2_vo_trig_over_fence", "after_mini_bridge", 0, 
									  "pier2vo_john_gotta_get_over_fence", &"PIER2VO_JOHN_GOTTA_GET_OVER_FENCE", 1.5);
	//At the fence
	thread pier2_vo_single_line_setup("pier2_vo_trig_cant_go_thru", "get_over_fence", 0.5, 
									  "pier2vo_john_cant_get_thru", &"PIER2VO_JOHN_CANT_GET_THRU_THIS_WAY", 1.5);
	//Top of crane
	thread pier2_vo_single_line_setup("pier2_vo_trig_crane_top", "top_of_crane", 1, 
									  "pier2vo_john_dead_end_or_is_it", &"PIER2VO_JOHN_DEAD_END_OR_IS_IT", 2.5);
	//Underwater grate
	thread pier2_vo_single_line_setup("pier2_vo_trig_bunker_dead_end", "bunker_dead_end", 0.5, 
									  "pier2vo_john_dead_end", &"PIER2VO_JOHN_DEAD_END", 1.5);
	
	thread pier2_dest_plane_fx();
}
pier2_init_before_pspawn()
{
	//do stuff with entities
	bridge = getentarray("pier2_bridge","targetname")[0];
	ship = getent("pier2_huge_ship","targetname");
	ship_models = getentarray("pier2_huge_ship_xmodels","targetname");
	manifest = getent("pier2_ship_manifest","targetname");
	cog = getent("pier2_ship_cog_pickup","targetname");
	bomb = getent("pier2_warehouse4_exp_bomb","targetname");
	wall_dest = getent("pier2_warehouse4_exp_destroyed","targetname");
	walkway_dest = getent("pier2_walkway_destroyed","targetname");
	speeder_trig = getent("pier2_speeder_ignition_trig","targetname");
	end_elevator = getent("pier2_end_gallery_elevator","targetname");
	end_elevator_intrig = getent("pier2_end_gallery_elevator_inside_ele_trig","targetname");
	end_elevator_killtrig= getent("pier2_end_gallery_elevator_kill_bottom","targetname");
	speeder_use = getent("pier2_speeder_model_use","targetname");
	speeder_use_coll = getent("pier2_speeder_collmap_use","targetname");
	gate_left = getent("pier2_ticket_office_gate_left","targetname");
	gate_right = getent("pier2_ticket_office_gate_right","targetname");
	radio_glow = getent("pier2_end_radio_glow_org","targetname");


	gate_left rotatePitch(-45, 0.1, 0.05, 0.05);
	gate_right rotatePitch(45, 0.1, 0.05, 0.05);
	
	bridge rotateroll(-60, 0.5, 0.25, 0.25);
	ship removeEnt();
	for(i=0;i<ship_models.size;i++)
		ship_models[i] removeEnt();
	bomb removeEnt();
	wall_dest removeEnt();
	walkway_dest removeEnt();
	manifest removeEnt();
	cog removeEnt();
	speeder_trig triggerOff();
	
	speeder_use removeEnt();
	speeder_use_coll removeEnt();
	
	end_elevator_intrig enableLinkTo();
	end_elevator_intrig linkTo(end_elevator);
	end_elevator_killtrig enableLinkTo();
	end_elevator_killtrig linkTo(end_elevator);
	
	
	//Set glowy stuff
	fuel = getent("pier2_speeder_fuel_can","targetname");
	key = getent("pier2_mansion_speeder_key","targetname");
	bomb_pickup = getent("pier2_storage_bomb_pickup","targetname");
	tools_trigs = getentarray("pier2_tool_trig","targetname");
	handle = getent("pier2_minibridge_handle","targetname");
	lockpicks = getent("pier2_lockpicks_pickup","targetname");
	boatyard_cog = getent("pier2_boatyard_cog","targetname");
	glasses = getent("pier2_secret_duke_glasses","targetname");
	picture = getent("pier2_mansion_switch_pic","targetname");
	end_ele_key = getent("pier2_end_elevator_key","targetname");
	
	for(i=0;i<tools_trigs.size;i++)
		getent(tools_trigs[i].target, "targetname")
			startGlowing();
	
	//cog startGlowing();
	bomb_pickup startGlowing();
	lockpicks startGlowing();
	boatyard_cog startGlowing();
	handle startGlowing();
	key startGlowing();
	fuel startGlowing();
	glasses startGlowing();
	picture startGlowing();
	end_ele_key startGlowing();
	radio_glow startGlowing();
}
pier2_on_player_connect()
{
	while(1)
	{
		level waittill("connecting", player);
		player thread pier2_init_player();
	}
}
pier2_init_player()
{
	if(!isDefined(self.resetPier2))
		self.resetPier2 = false;
		
	if(!self.resetPier2)
	{
		self.resetPier2 = true;
		
		self objectiveInit(); //objectives first
		self rezbarv2Init(); //then the HUD stuff
		self initMusicManager(); //then the music stuff
		
		self.toolCount = 0;
		self.hasTool = [];
		for(j=0;j<level.TOOL_COUNT;j++)
			self.hasTool[j] = false;
		
		self.replacedBattery = false;
		self.enabledGenerator3 = false;
		self.readManifest = false;
		self.photographedPlants = false;
		
		self.isInCinematic = false;
		self.isCamera = false;
		
		self.hasBombFromStorage = false;
		self.hasLockpicks = false;
		self.hasManifestWithCog = false;
		self.hasBoatyardCog = false;
		self.hasSpeederKey = false;
		self.hasSpeederFuel = false;
		self.hasElevatorKey = false;
		
		self.escapedBoatyard = false;
		self.hasTriggeredSpeederTrig = false;
		
		//special objectives that get added when only one player completes an event
		self.hasObjective5 = false;
		self.hasObjective10 = false;
		self.hasObjective13 = false;
		self.hasObjective14 = false;
		
		self vo_init();
		
		self playerSecretsInit();
		//self thread dev_cinematicMode();
		//self thread dev_printOrigin(true);
	}
}
bridge_sequence()
{
	b_l = getent("pier2_minibridge_left","targetname");
	b_lr = getent("pier2_minibridge_left_rail","targetname");
	b_r = getent("pier2_minibridge_right","targetname");
	b_rr = getent("pier2_minibridge_right_rail","targetname");
	
	b_l movex(512, 5.7, 2.5, 0.5);
	b_lr movex(512, 5.7, 2.5, 0.5);
	b_r movex(-512, 5.7, 2.5, 0.5);
	b_rr movex(-512, 5.7, 2.5, 0.5);
	b_lr playSound("pier2_minibridge_move_1");
	b_rr playSound("pier2_minibridge_move_1");
	wait 6;
	b_l movez(12, 0.5, 0.25, 0.25);
	b_lr movez(12, 0.5, 0.25, 0.25);
	b_r movez(12, 0.5, 0.25, 0.25);
	b_rr movez(12, 0.5, 0.25, 0.25);
	wait 0.25;
	b_lr playSound("pier2_minibridge_move_2");
	b_rr playSound("pier2_minibridge_move_2");
	wait 0.75;
	b_lr rotateroll(-180, 1.5, 0.5, 1);
	b_rr rotateroll(180, 1.5, 0.5, 1);
	wait 2;
}
bridge_hide()
{
	b_l = getent("pier2_minibridge_left","targetname");
	b_lr = getent("pier2_minibridge_left_rail","targetname");
	b_r = getent("pier2_minibridge_right","targetname");
	b_rr = getent("pier2_minibridge_right_rail","targetname");

	b_lr rotateroll(180, 0.05);
	b_rr rotateroll(-180, 0.05);
	wait 0.1;
	b_l movez(-12, 0.05);
	b_lr movez(-12, 0.05);
	b_r movez(-12, 0.05);
	b_rr movez(-12, 0.05);
	wait 0.1;
	b_l movex(-512, 0.05);
	b_lr movex(-512, 0.05);
	b_r movex(512, 0.05);
	b_rr movex(512, 0.05);
}
pier2_drowning_kill()
{
	t = getent("pier2_drowning_trig","targetname");
	while(1)
	{
		t waittill("trigger", user);
		user suicide();
		playfx(level.fx["pier2_death_splash"], user.origin);
		user playsound("bodyfall_water");
		user HUDFadeBlack(0.25, false, 1);
		wait 2;
		user HUDFadeBlack(0.25, true, 0);
	}
}
pier2_bridge_shortcut_fix()
{
	t = getent("pier2_bridge_shortcut_fix","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(level.bridge_lifting)
		{
			if(isAlive(user))
				user iprintlnbold(&"RZLPIER2_PRINTS_NO_CHEATING");
			user suicide();
		}
	}
}
pier2_wires_killthread()
{
	t = getentarray("pier2_wires_elec_trig","targetname");
	for(i=0;i<t.size;i++)
		t[i] thread _pier2_wires_think();
}
_pier2_wires_think()
{
	while(1)
	{
		self waittill("trigger", user);
		user playlocalsound("pier2_elec_wire_killsound");
		radiusdamage(user.origin, 32, 50, 1);
		//user suicide();
	}
}
pier2_minibridge_part()
{
	t = getent("pier2_minibridge_operator","targetname");
	h_ins = getent("pier2_minibridge_handle_inserted","targetname");
	h_ins removeEnt();
	bridge_hide();
	
	while(1)
	{
		t waittill("trigger", user);
		if(level.has_handle && !level.minibridge_lengthened)
		{
			h_ins showEnt();
			wait 0.1;
			h_ins rotatepitch(60, 1, 0.25, 0.25);
			h_ins playSound("pier2_minibridge_lever");
			wait 1;
			bridge_sequence();
			level.minibridge_lengthened = true;
		}
		else if(!level.has_handle)
			user iprintlnbold(&"RZLPIER2_PRINTS_NO_HANDLE_TO_USE");
		else user iprintln(&"RZLPIER2_PRINTS_DONT_NEED_TO_USE_HANDLE");
		
	}
}
pier2_minibridge_handle_pickup()
{
	h_out_trig = getent("pier2_minibridge_handle_pickup","targetname");
	h_out = getent("pier2_minibridge_handle","targetname");
	
	h_out notsolid();
	
	while(1)
	{
		h_out_trig waittill("trigger", user);
		user iprintln(&"RZLPIER2_PRINTS_YOU_PICK_UP_THE_HANDLE");
		h_out_trig delete();
		h_out hide();
		h_out stopGlowing();
		level.has_handle = true;
		break;
	}
}
pier2_small_dock_doors()
{
	d_l = getent("pier2_mini_pier_door_left","targetname");
	d_r = getent("pier2_mini_pier_door_right","targetname");
	t = getent("pier2_mini_pier_doors","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		d_l playsound("mini_doors_open");
		d_r playsound("mini_doors_open");
		d_l rotateyaw(85, 1.8, 0.2, 0.1);
		d_r rotateyaw(-85, 1.8, 0.2, 0.1);
		wait 1;
		t delete();
		break;
	}
}
pier2_battery_fix()
{
	t = getent("pier_battery_insert_garage_trig","targetname");
	b = getent("pier_battery_insert_garage","targetname");
	d = getent("pier_battery_insert_garage_fboxdoor","targetname");
	
	b hide();
	while(1)
	{
		t waittill("trigger", user);
		tool_cnt = 0;
		for(j=0;j<level.TOOL_COUNT;j++)
			if(user.hasTool[j])	
				tool_cnt++;
		if(tool_cnt==level.TOOL_COUNT && !user.replacedBattery)
		{
			d notsolid();
			d playsound("fusebox_open");
			d rotateyaw(-90, 0.5, 0.1, 0.25);
			wait 1;
			d playsound("battery_insert");
			b showEnt();
			wait 0.5;
			user iprintln(&"RZLPIER2_PRINTS_REPLACE_BATTERY_WITH_SPARE");
			d rotateyaw(90, 0.5, 0.25, 0.1);
			wait 0.45;
			d playsound("fusebox_close");
			b removeEnt();
			user.replacedBattery = true;
			user objectiveDelete(2);
			user objectiveAdd(3, "active", (568, 1978, 50), "objective", &"RZLPIER2_OBJ3_START_GENERATOR");
			user rezbarv2NotifySimple(&"RZLPIER2_OBJ_OBJECTIVES_UPDATED");
			wait 0.5;
			user rezbarv2NotifySimple(&"RZLPIER2_NOTIF_OBJ3_START_GENERATOR");
		}
		else if(user.replacedBattery) user iprintlnbold(&"RZLPIER2_PRINTS_ALREADY_REPLACED_BATTERY");
		else user iprintlnbold(&"RZLPIER2_PRINTS_DONT_HAVE_ALL_TOOLS");
	}
}
pier2_generator3_trig()
{
	t = getent("pier_generator_warehouse3_trig","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!user.enabledGenerator3 && user.replacedBattery)
		{
			user.enabledGenerator3 = true;
			user thread cutscene_generator3_on();
		}
		else if(!user.replacedBattery) user iprintlnbold(&"RZLPIER2_PRINTS_FIX_FUSEBOX_FIRST");
		else user iprintln(&"RZLPIER2_PRINTS_YOU_HAVE_ALREADY_DONE_THAT");
	}
}
cutscene_generator3_on()
{
	self cut_generator3Enable();
	
	self thread pier2_vo_single_line_say(0, "pier2vo_john_that_should_do_the_trick", &"PIER2VO_JOHN_THAT_SHOULD_DO_THE_TRICK", 1.5);
	self objectiveDelete(3);
	if(!level.bridge_raised)
		self objectiveAdd(4, "active", (-864, 2356, 56), "objective", &"RZLPIER2_OBJ4_LIFT_BRIDGE");
	self rezbarv2NotifySimple(&"RZLPIER2_OBJ_OBJECTIVES_UPDATED");
	wait 0.5;
	self rezbarv2NotifySimple(&"RZLPIER2_NOTIF_OBJ4_LIFT_BRIDGE");
}
pier2_bridge_control_door()
{
	t = getent("pier2_enter_south_bridge_control_t","targetname");
	o = getent("pier2_enter_south_bridge_control_o","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(user.enabledGenerator3)
		{
			user freezeControls(true);
			user.isInCinematic = true;
			user cutsceneChangeScene(o, 0.5, 0); //works for this particular case
			user.isInCinematic = false;
			user freezeControls(false);
			
			if(level.bridge_raised && !user.hasObjective5)
			{
				user.hasObjective5 = true;
				//user objectiveDelete(4); //obj 4 is only added if bridge hasn't been raised yet
				user objectiveAdd(5, "active", undefined, "objective", &"RZLPIER2_OBJ5_INV_SHIP");
				user objectiveAdd(6, "active", getent("pier2_ship_container_entrance_obj_org","targetname").origin, "objective", &"RZLPIER2_OBJ6_FIND_WAY_TO_BOARD_SHIP");
				user rezbarv2NotifySimple(&"RZLPIER2_OBJ_OBJECTIVES_UPDATED");
			}
		}
		else user iprintlnbold(&"RZLPIER2_PRINTS_ENABLE_GEN_IN_WAREHOUSE_3");
		
		wait 0.1;
	}
}
pier2_soundThread() //all the ambient sounds should go here, event sounds should stay in their own threads, this is for random looping sounds
{
	o = [];
	o[0] = spawn("script_origin", (-520, -3936, 38));
	o[0] playLoopSound("jeep_idle");
	
	o[1] = spawn("script_origin", (-754, 2420, 48));
	o[1] playLoopSound("pier2_bridge_control_generator_loop");
	
	//(-3320, 5234, 48)
}
pier2_cogs_bridge_control()
{
	cog = getentarray("pier2_generator_cog_bc","targetname");
	cog[0] thread moveCog(32);
	cog[2] thread moveCog(-32);
	
	cog[1] moveZ(-16, 0.5, 0.25, 0.25);
	cog[1] waittill("movedone");
	cog[1] thread moveCog(32);
}
pier2_intro_trigger()
{
	t = getent("pier2_start_trig","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		
		if(!isDefined(user.hasStartedIntro))
			user.hasStartedIntro = false;
		
		if(!user.hasStartedIntro)
		{
			user.hasStartedIntro = true;
			user HUDShowSkipText();
			user HUDFadeBlack(0, false, 1);
			user.compassSize = "1";
			user thread forceCompassSize(user.compassSize);
			wait 0.05;
			user thread pier2_intro();
		}
	}
}
pier2_intro()
{
	self endon("pier2_notify_intro_skipped");
	self freezeControls(true);
	self.intro_old_org = self setPoint();
	
	self cutsceneStart();
	self thread monitorIntroSkipPress();
	self sayLineSoundOnly("pier2vo_sfx_intro", 17);
	self sayLineSoundOnly("pier2vo_sfx_concrete_slam", 2);
	self shellshock("duhoc_boatexplosion", 5);
	
	self setOrigin(self.intro_old_org.origin - (0, 0, 50));
	self setPlayerAngles((self.angles[0], self.angles[1], 60));
	wait 0.5;
	self HUDFadeBlack(1, false, 0);
	wait 1;
	self HUDHideSkipText();
	self notify("pier2_notify_intro_ended");
	self cutsceneChangeScene(self.intro_old_org, 2, 0);
	self cutsceneEnd();
	
	self freezeControls(false);
	self thread rezbar_init_cine();
	self thread pier2_vo_threads_intro();
}
pier2_admin_door_left()
{
	t = getent("pier2_admin_door_left_trig","targetname");
	d1 = getent("pier2_admin_door_left","targetname");
	d2 = getent("pier2_ticket_office_entrance_left","targetname");

	d2 rotateyaw(90, 1, 0.5, 0.5);
	t maps\mp\_lockpicking::init(d1, (90, 0, 0));
}
pier2_admin_door_right()
{
	t = getent("pier2_admin_door_right_trig","targetname");
	d1 = getent("pier2_admin_door_right","targetname");
	d2 = getent("pier2_ticket_office_entrance_right","targetname");

	d2 rotateyaw(-90, 1, 0.5, 0.5);
	t maps\mp\_lockpicking::init(d1, (90, 0, 0));
}
pier2_warehouse4_bomb_sequence()
{
	bomb_obj = getent("pier2_warehouse4_exp_bomb_obj","targetname");
	bomb = getent("pier2_warehouse4_exp_bomb","targetname");
	wall = getent("pier2_warehouse4_exp_intact","targetname");
	wall_dest = getent("pier2_warehouse4_exp_destroyed","targetname");
	trig = getent("pier2_warehouse4_exp_trig","targetname");
	
	exp_org = bomb.origin - (10, 0, 0); //-10 units because it damages the wrong side of the wall
	
	BOMB_COUNTDOWN_TIME = 5;
	
	while(1)
	{
		trig waittill("trigger", user);
		if(user.hasBombFromStorage)
		{
			trig delete();
			bomb_obj removeEnt();
			bomb showEnt();
			user playSound("Explo_plant_no_tick");
			bomb playloopsound("bomb_tick");
			user setCountDown(BOMB_COUNTDOWN_TIME);
			bomb stoploopsound();
			bomb playSound("pier2_bomb_wall_exp");
			wait 0.1;
			playfx(level.fx["pier2_wall_exp"], bomb.origin);
			wall removeEnt();
			bomb removeEnt();
			wall_dest showEnt();
			radiusdamage(exp_org, 150, 250, 50);
		}
		else 
		{
			user iprintlnbold(&"RZLPIER2_PRINTS_DONT_HAVE_BOMB_SHOULD_BE_IN_STORAGE");
			if(!user.hasObjective14)
			{
				user.hasObjective14 = true;
				if(!user.currentlyTalking)
					user sayLine("pier2vo_john_explosives_around_here", &"PIER2VO_JOHN_EXPLOSIVES_AROUND_HERE", 2.5);
				
				user sayBlank();
				user objectiveAdd(14, "active", getent("pier2_storage_bomb_pickup_obj","targetname").origin, "objective", &"RZLPIER2_OBJ14_FIND_EXPLOSIVES_FOR_WALL");
				user rezbarv2NotifySimple(&"RZLPIER2_OBJ_OBJECTIVES_UPDATED");
				wait 0.5;
				user rezbarv2NotifySimple(&"RZLPIER2_NOTIF_OBJ14_FIND_EXPLOSIVES_FOR_WALL");
			}
		}
	}
}
pier2_storage_stuff()
{
	t = getent("pier2_storage_bomb_pickup_trig","targetname");
	b = getent("pier2_storage_bomb_pickup","targetname");
	obj = getent("pier2_storage_bomb_pickup_obj","targetname");
	obj show();
	while(1)
	{
		t waittill("trigger", user);
		if(!user.hasBombFromStorage)
		{
			if(user.hasObjective14)
				user objectiveDelete(14);
			
			user.hasBombFromStorage = true;
			user iprintln(&"RZLPIER2_PRINTS_YOU_PICK_UP_THE_BOMB");
			b removeEnt();
			b stopGlowing();
			obj removeEnt();
			wait 2;
			b showEnt();
			b startGlowing();
			obj showEnt();
		} 
		else user iprintln(&"RZLPIER2_PRINTS_ALREADY_PICKED_UP_BOMB");
		wait 1;
	}
}
pier2_ship_manifest_pickup()
{
	manifest = getent("pier2_ship_manifest","targetname");
	cog = getent("pier2_ship_cog_pickup","targetname");
	manifest_t = getent("pier2_ship_manifest_trig","targetname");
	cont_t = getent("pier2_container_enter_trig","targetname");
	cont_t triggerOff();
	
	while(1)
	{
		manifest_t waittill("trigger", user);
		if(!user.hasManifestWithCog)
		{
			manifest_t triggerOff();
			user.hasManifestWithCog = true;
			manifest removeEnt();
			user iprintln(&"RZLPIER2_PRINTS_YOU_PICK_UP_THE_MANIFEST");
			user objectiveDelete(7);
			user rezbarv2NotifySimple(&"RZLPIER2_OBJ_OBJECTIVES_UPDATED");
			wait 1;
			cog removeEnt();
			user iprintln(&"RZLPIER2_PRINTS_YOU_PICK_UP_THE_EXTRA_COG");
			wait 1;
			cog showEnt();
			manifest showEnt();
			user readBook("pier2_manifest_paper");
			user.readManifest = true;
			cont_t triggerOn();
			cont_t thread pier2_ship_container_enter();
			manifest_t triggerOn();
			user thread pier2_vo_single_line_say(0, "pier2vo_john_biohazard_symbol", &"PIER2VO_JOHN_BIOHAZARD_SYMBOL", 4);
			user rezbarv2NotifySimple(&"RZLPIER2_NOTIF_OBJ8_PHOTO_PLANTS");
			user objectiveAdd(8, "active", getent("pier2_container_enter_org","targetname").origin, "objective", &"RZLPIER2_OBJ8_PHOTO_PLANTS");
		}
		else user iprintln(&"RZLPIER2_PRINTS_ALREADY_PICKED_UP_MANIFEST");
	}
}
pier2_ship_container_enter()
{
	o = getent("pier2_container_enter_org","targetname");
	while(1)
	{
		self waittill("trigger", user);
		if(user.readManifest)
		{
			user freezeControls(true);
			user.isInCinematic = true;
			user cutsceneChangeScene(o, 0.5, 0);
			user.isInCinematic = false;
			user freezeControls(false);
		} else user iprintln(&"RZLPIER2_PRINTS_NEED_TO_GET_MANIFEST_FIRST");
	}
}
pier2_ship_container_exit()
{
	t = getent("pier2_container_exit_trig","targetname");
	o = getent("pier2_container_exit_org","targetname");
	while(1)
	{
		t waittill("trigger", user);
		if(user.photographedPlants)
		{
			user freezeControls(true);
			user.isInCinematic = true;
			user cutsceneChangeScene(o, 0.5, 0);
			user.isInCinematic = false;
			user freezeControls(false);
		} else user iprintln(&"RZLPIER2_PRINTS_NEED_TO_PHOTOGRAPH_PLANTS_FIRST");
	}
}
pier2_ship_drop_trig()
{
	t = getent("pier2_ship_drop_trig","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!isDefined(user.voEventFlags["ship_drop_trig"]))
			user.voEventFlags["ship_drop_trig"] = false;
			
		if(!user.voEventFlags["ship_drop_trig"])
		{
			user.voEventFlags["ship_drop_trig"] = true;
			user thread _trig_ship_drop();
		}
		
	}
}
_trig_ship_drop()
{
	playFx(level.fx["pier2_ship_drop_white_smoke"], self.origin);
	if(!self.currentlyTalking)
	{
		self.currentlyTalking = true;
		self playSound("pier2_ship_drop_splat");
		self sayLineSoundOnly("pier2vo_john_pain_1", 1.5);
		self sayLine("pier2vo_john_that_was_close", &"PIER2VO_JOHN_THAT_WAS_CLOSE", 2);
		self sayLine("pier2vo_taylor_be_careful_john", &"PIER2VO_TAYLOR_BE_CAREFUL_JOHN", 1.5);
		self sayBlank();
		self.currentlyTalking = false;
	}
	self objectiveDelete(6);
	self objectiveAdd(7, "active", getent("pier2_ship_cog_pickup","targetname").origin, "objective", &"RZLPIER2_OBJ7_GET_MANIFEST");
	self rezbarv2NotifySimple(&"RZLPIER2_OBJ_OBJECTIVES_UPDATED");
	wait 0.5;
	self rezbarv2NotifySimple(&"RZLPIER2_NOTIF_OBJ7_GET_MANIFEST");
}
pier2_walkway_sequence()
{
	w_intact = getent("pier2_walkway_intact","targetname");
	w_dest = getent("pier2_walkway_destroyed","targetname");
	w_dest removeEnt();
	arr_boxes = getentarray("pier2_walkway_seq_boxes","targetname");
	arr_bombs = getentarray("pier2_walkway_seq_bombs","targetname");
	arr_boxclip = getentarray("pier2_walkway_seq_boxes_clip","targetname");
	arr_dmgtrig = getent("pier2_walkway_seq_dmgtrig","targetname");
	door = getent("pier2_walkway_seq_dirt_door","targetname");
	o = getent("pier2_walkway_seq_exp_org","targetname"); 
	
	arr_dmgtrig thread pier2_walkway_trig_think(w_intact, w_dest, arr_boxes, arr_bombs, arr_boxclip, level.fx["pier2_walkway_exp"], o, door);
}
pier2_walkway_trig_think(intact, destroyed, boxes, bombs, boxclips, fx, org, door)
{
	while(1)
	{
		self waittill("damage", dmg, user);
		if(!level.walkway_destroyed)
		{
			if(dmg>60)
			{
				level.walkway_destroyed = true;
				thread pier2_walkway_door_fx(level.fx["pier2_door_outward_smoke"]);
				wait 0.1;
				playfx(fx, org.origin);
				for(i=0;i<boxclips.size;i++)
				{
					boxes[i] removeEnt();
					boxclips[i] removeEnt();
				}
				for(j=0;j<bombs.size;j++)
					bombs[j] removeEnt();
					
				intact removeEnt();
				destroyed showEnt();
				door removeEnt();
				org playSound("pier2_walkway_exp");
				radiusdamage(org.origin, 350, 100, 100);
				user thread pier2_vo_threads_walkway();
			}
		}
		else break;
		wait 0.1;
	}
}
pier2_walkway_door_fx(fx)
{
	origin = (544, 6532, 332);
	playFx(fx, origin);
}
pier2_mansion_sliding_doors()
{
	trigs = [];
	doors = [];
	trigs[0] = getent("pier2_mansion_slide_door_left_trig","targetname");
	trigs[1] = getent("pier2_mansion_slide_door_right_trig","targetname");
	doors[0] = getent("pier2_mansion_slide_door_left","targetname");
	doors[1] = getent("pier2_mansion_slide_door_right","targetname");
	
	trigs[0] thread pier2_mansion_slide_door_think(doors[0], true);
	trigs[1] thread pier2_mansion_slide_door_think(doors[1], false);
}
pier2_mansion_slide_door_think(d, lr)
{
	self waittill("trigger", user);
	if(lr) d moveX(56,2.5,0.2,0.1);
	else d moveX(-56,2.5,0.2,0.1);
	d playsound("pier2_sliding_door");
	wait 3;
	
	if(!isDefined(user.voEventFlags["mansion_top_floor"]))
		user.voEventFlags["mansion_top_floor"] = false;
		
	if(!user.voEventFlags["mansion_top_floor"])
	{
		user.voEventFlags["mansion_top_floor"] = true;
		
		if(!user.currentlyTalking)
		{
			user.currentlyTalking = true;
			user sayLine("pier2vo_john_hm_this_must_be_the_place", &"PIER2VO_JOHN_HM_THIS_MUST_BE_THE_PLACE", 2.5);
			user sayBlank();
			user.currentlyTalking = false;
		}
	}
	
	self delete();
}
pier2_lockpicks()
{
	t = getent("pier2_lockpicks_pickup_trig","targetname");
	p = getent("pier2_lockpicks_pickup","targetname");
	p_obj = getent("pier2_lockpicks_pickup_obj","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!user.hasLockpicks)
		{
			user.hasLockpicks = true;
			p_obj removeEnt();
			p stopGlowing();
			user iprintln(&"RZLPIER2_PRINTS_YOU_PICK_UP_THE_LOCKPICKS");
			wait 2;
			p_obj showEnt();
			p startGlowing();
		}
		else user iprintln(&"RZLPIER2_PRINTS_ALREADY_PICKED_UP_LOCKPICKS");
		wait 0.5;
	}
}
pier2_plants_photographing()
{
	t = getent("pier2_container_photo_trig","targetname");
	t sethintstring(&"RZLPIER2_HINTSTRING_PRESS_USE_TO_PHOTOGRAPH_PLANTS");
	o = getent("pier2_container_plants_photo_org","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!user.photographedPlants)
		{
			t triggerOff();
			org = user setPoint();
			user freezeControls(true);
			user holsterWeapons("holster");
			user makeCamera(true);
			user.isInCinematic = true;
			user cutsceneChangeScene(o, 0.25, 65);
			user setCountDown(2);
			user takePicture(2, 0.8, 0);
			user cutsceneChangeScene(org, 0.25, 0);
			user freezeControls(false);
			user makeCamera(false);
			user.isInCinematic = false;
			user.photographedPlants = true;
			user holsterWeapons("retrieve");
			t triggerOn();
			user thread pier2_vo_threads_photographed();
			user thread _plants_photo_rezbar_cine();
		} else user iprintln(&"RZLPIER2_PRINTS_YOU_HAVE_ALREADY_DONE_THAT");
	}
}
_plants_photo_rezbar_cine()
{
	self objectiveDelete(8);
	self objectiveDelete(5);
	self rezbarv2Notify(&"RZLPIER2_REZBAR_ESTABLISHING_LINK", "rezbarv2_notif_2", true);
	self rezbarv2Load(3, 0.5);
	self rezbarv2Notify(&"RZLPIER2_REZBAR_ESTABLISHED_LINK", "rezbarv2_notif_2", true);
	wait 1;
	self rezbarv2Notify(&"RZLPIER2_REZBAR_UPLOADING_PICTURE", "rezbarv2_notif", true);
	self rezbarv2Load(5, 0.25);
	self rezbarv2Notify(&"RZLPIER2_REZBAR_UPLOADED_PICTURE", "rezbarv2_notif", true);
	wait 0.75;
	self rezbarv2NotifySimple(&"RZLPIER2_REZBAR_LINK_TERMINATED");
	wait 2;
	self objectiveAdd(9, "active", undefined, "objective", &"RZLPIER2_OBJ9_ACCESS_OTHER_SIDE");
	self rezbarv2NotifySimple(&"RZLPIER2_OBJ_OBJECTIVES_UPDATED");
	wait 0.5;
	self rezbarv2NotifySimple(&"RZLPIER2_NOTIF_OBJ9_ACCESS_OTHER_SIDE");
}
pier2_boatyard_generator_insert_trig()
{
	t = getent("pier2_boatyard_cog_insert","targetname");
	oc = getent("pier2_boatyard_office_cog","targetname");
	sc = getent("pier2_boatyard_ship_cog","targetname");
	ic = getent("pier2_boatyard_inserted_cog","targetname");
	
	oc removeEnt();
	sc removeEnt();
	
	while(1)
	{
		t waittill("trigger", user);
		if(user.hasManifestWithCog && !user.hasBoatyardCog)
			user iprintlnbold(&"RZLPIER2_PRINTS_NEED_ANOTHER_COG");
		else if(user.hasManifestWithCog && user.hasBoatyardCog)
		{
			user objectiveDelete(30);
			if(!level.boatyard_generator_on)
			{
				level.boatyard_generator_on = true;
				//play sound of inserting cogs
				ic moveZ(-16, 0.5, 0.25, 0.25);
				sc moveZ(32, 1, 0.25, 0.25);
				sc waittill("movedone");
				sound_org = spawn("script_origin", (-3320, 5234, 48));
				sound_org playLoopSound("pier2_bridge_control_generator_loop");
				ic thread moveCog(32);
				oc showEnt();
				oc thread moveCog(-32);
				sc showEnt();
				sc thread moveCog(-32);
			}
			else user iprintln(&"RZLPIER2_PRINTS_YOU_DONT_NEED_TO_DO_THAT_ANYMORE");
		}
	}
}
pier2_boatyard_office_cog()
{
	t = getent("pier2_boatyard_cog_pickup","targetname");
	c = getent("pier2_boatyard_cog","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!user.hasBoatyardCog)
		{
			t triggerOff();
			user.hasBoatyardCog = true;
			user iprintln(&"RZLPIER2_PRINTS_YOU_PICK_UP_THE_COG");
			c removeEnt();
			c stopGlowing();
			wait 1;
			c showEnt();
			c startGlowing();
			t triggerOn();
		}
		else user iprintln(&"RZLPIER2_PRINTS_ALREADY_HAVE_THIS_COG");
	}
}
pier2_boatyard_office_door()
{
	t = getent("pier2_boatyard_office_doortrig","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!user.currentlyTalking)
		{
			user.currentlyTalking = true;
			user sayLineSoundOnly("pier2_door_locked", 0.5);
			user sayLine("pier2vo_john_locked", &"PIER2VO_JOHN_LOCKED", 2);
			user sayBlank();
			user.currentlyTalking = false;
		}
	}
}
pier2_boatyard_entrance()
{
	t = getent("pier2_boatyard_entrance_door_trig","targetname");
	o = getent("pier2_boatyard_entrance_door_org","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!user.hasLockpicks)
		{
			user iprintlnbold(&"RZLPIER2_PRINTS_NO_CHEATING_LOCKPICKS");
			user suicide();
		}
		else if(user.hasManifestWithCog && user.photographedPlants)
		{
			user freezeControls(true);
			user.isInCinematic = true;
			user cutsceneChangeScene(o, 0.5, 0); //works for this particular case
			user.isInCinematic = false;
			user freezeControls(false);
			
			if(level.speeder_dropped && !user.hasObjective10)
			{
				user.hasObjective10 = true;
				user objectiveAdd(10, "active", (-3736, 5720, -72), "objective", &"RZLPIER2_OBJ10_CHECK_SPEEDER_FUNCTIONAL");
				user rezbarv2NotifySimple(&"RZLPIER2_NOTIF_OBJ10_CHECK_SPEEDER_FUNCTIONAL");
			}
		}
		else user iprintlnbold(&"RZLPIER2_PRINTS_NEED_TO_COMPLETE_OBJS_ON_SHIP_FIRST");
	}
}
pier2_end_elevator_btn(targetname, location)
{
	ele = getent("pier2_end_gallery_elevator","targetname");
	t = getent(targetname,"targetname");
	
	in_t = getent("pier2_end_gallery_elevator_inside_ele_trig","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!user.hasElevatorKey)
			user iprintlnbold(&"RZLPIER2_PRINTS_NEED_ELEVATOR_KEY_TO_USE_ELE");
		else
		{
			if(level.end_elevator_location!=location && !level.end_elevator_moving)
			{
				level.end_elevator_moving = true;
				if(location)
				{
					ele moveZ(828, 8, 1, 1);
					in_t sethintstring(&"RZLPIER2_HINTSTRING_END_ELEVATOR_GOING_UP");
				}
				else
				{
					ele moveZ(-828, 8, 1, 1);
					in_t sethintstring(&"RZLPIER2_HINTSTRING_END_ELEVATOR_GOING_DOWN");
				}
				ele waittill("movedone");
				level.end_elevator_moving = false;
				level.end_elevator_location = location;
				
				if(level.end_elevator_location)
					in_t sethintstring(&"RZLPIER2_HINTSTRING_END_ELEVATOR_PRESS_USE_TO_GO_DOWN");
				else in_t sethintstring(&"RZLPIER2_HINTSTRING_END_ELEVATOR_PRESS_USE_TO_GO_UP");
			}
			else if(level.end_elevator_location==location)
				user iprintln(&"RZLPIER2_PRINTS_ELEVATOR_IS_ALREADY_HERE");
			else if(level.end_elevator_moving)
				user iprintln(&"RZLPIER2_PRINTS_ELEVATOR_ON_ITS_WAY");
		}
		wait 1;
	}
}
pier2_end_elevator_inside_ele_trig()
{
	t = getent("pier2_end_gallery_elevator_inside_ele_trig","targetname");
	t sethintstring(&"RZLPIER2_HINTSTRING_END_ELEVATOR_PRESS_USE_TO_GO_UP");
	ele = getent("pier2_end_gallery_elevator","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!user.hasElevatorKey)
			user iprintlnbold(&"RZLPIER2_PRINTS_NEED_ELEVATOR_KEY_TO_USE_ELE");
		else
		{
			if(!level.end_elevator_moving)
			{
				level.end_elevator_moving = true;
				if(!level.end_elevator_location)
				{
					ele moveZ(828, 8, 1, 1);
					t sethintstring(&"RZLPIER2_HINTSTRING_END_ELEVATOR_GOING_UP");
				}
				else 
				{
					ele moveZ(-828, 8, 1, 1);
					t sethintstring(&"RZLPIER2_HINTSTRING_END_ELEVATOR_GOING_DOWN");
				}
				ele waittill("movedone");
				level.end_elevator_moving = false;
				level.end_elevator_location = !level.end_elevator_location;
				if(level.end_elevator_location)
					t sethintstring(&"RZLPIER2_HINTSTRING_END_ELEVATOR_PRESS_USE_TO_GO_DOWN");
				else t sethintstring(&"RZLPIER2_HINTSTRING_END_ELEVATOR_PRESS_USE_TO_GO_UP");
			}
		}
		wait 1;
	}
}
pier2_end_elevator_killtrig()
{
	t = getent("pier2_end_gallery_elevator_kill_bottom","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		user suicide();
	}
}
pier2_end_elevator_key()
{
	k = getent("pier2_end_elevator_key","targetname");
	t = getent("pier2_end_elevator_key_trig","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!isDefined(user.hasElevatorKey))
			user.hasElevatorKey = false;
			
		if(!user.hasElevatorKey)
		{
			user.hasElevatorKey = true;
			k removeEnt();
			k stopGlowing();
			user iprintlnbold(&"RZLPIER2_PRINTS_YOU_PICK_UP_THE_ELEVATOR_KEY");
			wait 2;
			k showEnt();
			k startGlowing();
		} else user iprintln(&"RZLPIER2_PRINTS_ALREADY_PICKED_UP_KEY");
	}
}
pier2_end_lounge_door(trig_targetname, org_targetname)
{
	t = getent(trig_targetname, "targetname");
	o = getent(org_targetname, "targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		user freezeControls(true);
		user.isInCinematic = true;
		user cutsceneChangeScene(o, 0.5, 0);
		user.isInCinematic = false;
		user freezeControls(false);
	}
}
pier2_end_lounge_musicbox()
{
	t = getent("pier2_end_lounge_musictrig","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!isDefined(user.isInRelaxationMode))
			user.isInRelaxationMode = false;
			
		if(!user.isInRelaxationMode)
		{
			user.isInRelaxationMode = true;
			user thread _pier2_musicbox_relax_mode();
		}
		else
		{
			user notify("pier2_relax_mode_stopped");
			
			user.isInRelaxationMode = false;
			user thread HUDFadeBlack(1, true, 0);
			user stopMusicBits();
		}
		
		wait 0.5;
	}
}
_pier2_musicbox_relax_mode()
{
	self endon("pier2_relax_mode_stopped");
	
	self thread HUDFadeBlack(1, true, 0.25);
	self playUniqueMusicBit("dark_coffee");
	self thread HUDFadeBlack(1, true, 0);
	self.isInRelaxationMode = false;
}
pier2_crane_top_ambient()
{
	t = getent("pier2_ambtrig_crane","targetname");
	while(1)
	{
		t waittill("trigger", user);
		if(!isDefined(user.craneTopAmbient))
			user.craneTopAmbient = false;
			
		if(!user.craneTopAmbient)
		{
			user.craneTopAmbient = true;
			user thread playUniqueMusicBit("ambience_music_climbing_crane");
		}
	}
}
pier2_ticket_office_voice_trig()
{
	t = getent("pier2_ticket_office_voice_trig","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!isDefined(user.voEventFlags["ticket_office"]))
			user.voEventFlags["ticket_office"] = false;
			
		if(!user.voEventFlags["ticket_office"] && !user.currentlyTalking)
		{
			user.voEventFlags["ticket_office"] = true;
			user thread pier2_vo_threads_ticket_office();
		}
	}
}
pier2_electric_wire_loop()
{
	while(1)
	{
		wireLightFlicker(false);
		wait 1;
		wireLightFlicker(true);
		wait 0.1;
		wireLightFlicker(false);
		wait 0.1;
		wireLightFlicker(true);
		wait 0.1;
		wireLightFlicker(false);
		wait 1.5;
		wireLightFlicker(true);
		wait 0.4;
		
	}
}
wireLightFlicker(arg)
{
	t = getent("pier2_flickering_wire_trig","targetname");
	w = getent("pier2_flickering_wire","targetname");
	l = getent("pier2_flickering_light","targetname");
	
	t triggerOff();
	
	if(!arg)
	{
		l setmodel("xmodel/prop_lamp01");
		l playsound("null");
	}
	else
	{
		l setmodel("xmodel/prop_lamp01_on");
		l playsound("pier2_flickering_light_hum");
	}
}
pier2_speeder_key()
{
	t = getent("pier2_mansion_speeder_key_trig","targetname");
	k = getent("pier2_mansion_speeder_key","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!user.hasSpeederKey)
		{
			user.hasSpeederKey = true;
			user iprintln(&"RZLPIER2_PRINTS_YOU_PICK_UP_SPEEDER_KEY");
			user objectiveDelete(11);
			user thread pier2_check_both_speeder_components();
			k removeEnt();
			k stopGlowing();
			wait 1;
			k showEnt();
			k startGlowing();
			
			user objectiveDelete(13);
			user objectiveAdd(15, "active", (536, 5768, 296), "objective", &"RZLPIER2_OBJ15_GET_TO_OFFICE_BLDG");
			user rezbarv2NotifySimple(&"RZLPIER2_OBJ_OBJECTIVES_UPDATED");
			wait 0.5;
			user rezbarv2NotifySimple(&"RZLPIER2_NOTIF_OBJ15_GET_TO_OFFICE_BLDG");
		} else user iprintln(&"RZLPIER2_PRINTS_ALREADY_PICKED_UP_KEY");
	}
}

pier2_mansion_pic_trig()
{
	t = getent("pier2_mansion_switch_pic_trig","targetname");
	p = getent("pier2_mansion_switch_pic","targetname");
	
	b = getent("pier2_mansion_bed_model","targetname");
	b_coll = getent("pier2_mansion_bed_collmap","targetname");
	o = getent("pier2_bed_cine_org","targetname");
	
	p rotatepitch(30, 0.1);
	
	while(1)
	{
		t waittill("trigger", user);
		if(!level.bed_moved)
		{
			level.bed_moved = true;
			p stopGlowing();
			p rotatepitch(-30, 1, 0.25, 0.25);
			wait 1;
			user clearPrintLn(true);
			user clearPrintLn(false);
			back = user setPointVec(-520, 7952, 256);
			user cutsceneStart();
			user cutsceneChangeScene(o, 0.25, 65);
			user thread playUniqueMusicBit("ambience_music_bed");
			wait 0.25;
			b moveX(-80, 2, 1, 1);
			b_coll moveX(-80, 2, 1, 1);
			wait 2;
			user cutsceneChangeScene(back, 0.25, 0);
			user cutsceneEnd();
		} else user iprintln(&"RZLPIER2_PRINTS_YOU_DONT_NEED_TO_DO_THAT_ANYMORE");
	}
}

pier2_dest_plane_fx()
{
	o = getent("pier2_plane_destroyed_fx","targetname");
	
	while(1)
	{
		playFx(level.fx["cruise_exhaust_black_smoke"], o.origin);
		wait 0.5;
	}
}

pier2_speeder_fuel()
{
	f = getent("pier2_speeder_fuel_can","targetname");
	t = getent("pier2_speeder_fuel_can_trig","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!user.hasSpeederFuel)
		{
			user.hasSpeederFuel = true;
			user iprintln(&"RZLPIER2_PRINTS_YOU_PICK_UP_SPEEDER_FUEL");
			user objectiveDelete(12);
			user thread pier2_check_both_speeder_components();
			f stopGlowing();
			f removeEnt();
			wait 1;
			f showEnt();
			f startGlowing();
		} else user iprintln(&"RZLPIER2_PRINTS_ALREADY_HAVE_SPEEDER_FUEL");
	}
}
pier2_check_both_speeder_components()
{
	if(self.hasSpeederKey && self.hasSpeederFuel)
	{
		self objectiveAdd(16, "active", getent("pier2_speeder_model","targetname").origin, "objective", &"RZLPIER2_OBJ16_ESCAPE");
		self rezbarv2NotifySimple(&"RZLPIER2_OBJ_OBJECTIVES_UPDATED");
		wait 0.5;
		self rezbarv2NotifySimple(&"RZLPIER2_NOTIF_OBJ16_ESCAPE");
	}
}

pier2_speeder_ignition_trig()
{
	t = getent("pier2_speeder_ignition_trig","targetname");
	ac_t = getent("pier2_speeder_use_anticheat_trig", "targetname");
	
	speeder_use = getent("pier2_speeder_model_use","targetname");
	speeder_use_coll = getent("pier2_speeder_collmap_use","targetname");
	speeder_wake_fx_org = getent("pier2_fx_org_speeder_wake","targetname");
	speeder_player_link_org = getent("pier2_speeder_use_playerlink_org","targetname");
	
	ac_t enableLinkTo();
	ac_t linkTo(speeder_use);
	
	while(1)
	{
		t waittill("trigger", user);
		if(user.hasObjective10 && !user.hasTriggeredSpeederTrig)
		{
			user.hasTriggeredSpeederTrig = true;
			user objectiveDelete(10);
			
			user objectiveAdd(11, "active", (-353, 7692, 290), "objective", &"RZLPIER2_OBJ11_FIND_KEYS_FOR_SPEEDER");
			user objectiveAdd(12, "active", (3664, 5352, 1070), "objective", &"RZLPIER2_OBJ12_FIND_FUEL_FOR_SPEEDER");
			user rezbarv2NotifySimple(&"RZLPIER2_OBJ_OBJECTIVES_UPDATED");
		}
		
		if(!user.hasSpeederkey)
			user iprintlnbold(&"RZLPIER2_PRINTS_NEED_TO_FIND_SPEEDER_KEY_FIRST");
		else if(!user.hasSpeederFuel)
			user iprintlnbold(&"RZLPIER2_PRINTS_NEED_TO_FIND_SPEEDER_FUEL");
		else
		{
			//if(!user.escapedBoatyard)
			//{
				user.escapedBoatyard = true;
				
				user.rezbarv2state = false;
				user rezbarv2HideObjectives();
				
				t triggerOff();
				user objectiveDelete(16);
				wait 0.05;
				user thread endingAntiCheat(ac_t);
				user thread playUniqueMusicBit("ambience_music_ending_credits");
				
				user linkTo(speeder_player_link_org);
				user thread holsterWeapons("holster");
				//user thread loopWakeFx("pier2_fx_org_speeder_wake", 0, 0, -1);
				
				speeder_use moveX(-14496, 120, 5, 5);
				speeder_use_coll moveX(-14496, 120, 5, 5);
				speeder_player_link_org moveX(-14496, 120, 5, 5);
				speeder_wake_fx_org moveX(-14496, 120, 5, 5);
				
				wait 1.5;
				user iprintlnbold(&"RZLPIER2_PRINTS_ENDING_LINE_1", user.name);
				wait 3;
				user iprintlnbold(&"RZLPIER2_PRINTS_ENDING_LINE_2");
				wait 3;
				user iprintlnbold(&"RZLPIER2_PRINTS_ENDING_LINE_3");
				wait 3;
				user iprintlnbold(&"RZLPIER2_PRINTS_ENDING_LINE_4");
				wait 2.5;
				
				user clearPrintLn(true);
				user thread startCredits();
				
				speeder_use waittill("movedone");
				user notify("pier2_anticheat_got_to_end");
				
				if(user hasAllSecrets())
				{
					user unlink();
					user notify("pier2_notify_stop_wake_fx");
					user thread holsterWeapons("retrieve");
				}
				wait 10; //Wait a bit for the player to get off the boat
				speeder_use removeEnt();
				speeder_use_coll removeEnt();
				
				speeder_use moveX(14496, 0.5, 0.25, 0.25);
				speeder_use_coll moveX(14496, 0.5, 0.25, 0.25);
				speeder_player_link_org moveX(14496, 0.5, 0.25, 0.25);
				speeder_wake_fx_org moveX(14496, 0.5, 0.25, 0.25);
				
				wait 1;
				speeder_use showEnt();
				speeder_use_coll showEnt();
				t triggerOn();
			//} else user iprintlnbold("You've already finished the map!");
		}
	}
}
pier2_easteregg_dukemode_trig()
{
	t = getent("pier2_secret_duke_trig","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		user thread easterEggDukeMode();
	}
}
pier2_easteregg_skyscraper_enter()
{
	t = getent("pier2_secret_trig_bonus_jumps_1", "targetname");
	o = getent("pier2_skyscraper_dest_org", "targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		user.isInCinematic = true;
		user cutsceneChangeScene(o, 0, 0);
		user.isInCinematic = false;
		
		user iprintlnbold(&"RZLPIER2_PRINTS_BONUS_SKYSCRAPER_TOP");
	}
}
pier2_boatyard_fence_ledge()
{
	t = getent("pier2_obj_trig_boatyard_wall","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(level.boatyard_generator_on)
			user objectiveDelete(30);
		
		if(!user.hasObjective13)
		{
			user.hasObjective13 = true;
			user objectiveDelete(9);
			if(user.hasObjective10 && !user.hasTriggeredSpeederTrig)
			{
				user.hasTriggeredSpeederTrig = true;
				user objectiveDelete(10);
				
				user objectiveAdd(11, "active", (-353, 7692, 290), "objective", &"RZLPIER2_OBJ11_FIND_KEYS_FOR_SPEEDER");
				user objectiveAdd(12, "active", (3664, 5352, 1070), "objective", &"RZLPIER2_OBJ12_FIND_FUEL_FOR_SPEEDER");
			}
			user objectiveAdd(13, "active", (3664, 5352, 1070), "objective", &"RZLPIER2_OBJ13_GET_TO_MANSION");
			
			user rezbarv2NotifySimple(&"RZLPIER2_OBJ_OBJECTIVES_UPDATED");
		}
	}
}
pier2_after_walkway_trig()
{
	t = getent("pier2_obj_trig_after_walkway","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		
		if(!isDefined(user.voEventFlags["after_walkway"]))
			user.voEventFlags["after_walkway"] = false;
			
		if(!user.voEventFlags["after_walkway"])
		{
			user.voEventFlags["after_walkway"] = true;
			user objectiveDelete(15);
		}
	}
}
pier2_bunker_trig()
{
	t = getent("pier2_vo_trig_mansion_bunker","targetname");
	p = getent("pier2_mansion_switch_pic","targetname");
	
	b = getent("pier2_mansion_bed_model","targetname");
	b_coll = getent("pier2_mansion_bed_collmap","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(level.bed_moved)
		{
			p rotatepitch(30, 1, 0.25, 0.25);
			p startGlowing();
			b moveX(80, 2, 1, 1);
			b_coll moveX(80, 2, 1, 1);
			wait 1.25;
			level.bed_moved = false;
		}
		
		user thread pier2_vo_threads_bunker();
		wait 0.5;
	}
}

rezbar_init_cine()
{
	self thread rezbarv2Load(4, 0.1);
	
	self rezbarv2NotifySimple(&"RZLPIER2_REZBAR_INITIALIZING");
	wait 2;
	self rezbarv2NotifySimple(&"RZLPIER2_REZBAR_INITIALIZING");
	wait 2;
	self rezbarv2NotifySimple(&"RZLPIER2_REZBAR_INITIALIZED");
	self thread rezbarv2MonitorUserKeys();
	wait 2;
	self thread pickup_tools_obj();
}

pickup_tools_obj()
{
	self rezbarv2NotifySimple(&"RZLPIER2_NOTIF_OBJ1_FIND_TOOLS");
	tr = getentarray("pier2_tool_trig","targetname");
	
	for(i=0;i<level.TOOL_COUNT;i++)
	{
		to = getent(tr[i].target, "targetname");
		
		if(i==2)
			self objectiveAdd(i, "active", to.origin, "objective", &"RZLPIER2_OBJ1_FIND_TOOLS");
		else self objectiveAdd(i, "current", to.origin, "objective", &"RZLPIER2_BLANK");
	}
}

pier2_admin_office_vo_trig()
{
	t = getent("pier2_admin_after_voice_trig","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!user.hasLockpicks)
		{
			user iprintlnbold(&"RZLPIER2_PRINTS_NO_CHEATING_LOCKPICKS");
			user suicide();
		}
		else
		{
			if(!isDefined(user.voEventFlags["admin_house"]))
				user.voEventFlags["admin_house"] = false;
				
			if(!user.voEventFlags["admin_house"] && !user.currentlyTalking)
			{
				user.voEventFlags["admin_house"] = true;
				if(!level.minibridge_lengthened)
					user thread pier2_vo_single_line_say(0, "pier2vo_john_hm_how_to_get_over_there", &"PIER2VO_JOHN_HM_HOW_TO_GET_OVER_THERE", 3);
			}
		}
	}
}

pier2_weap_storage_vo_trig()
{
	t = getent("pier2_vo_trig_storage_weaps","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!isDefined(user.voEventFlags["weap_storage"]))
			user.voEventFlags["weap_storage"] = false;
			
		if(!user.voEventFlags["weap_storage"] && !user.currentlyTalking)
		{
			user.voEventFlags["weap_storage"] = true;
			user thread pier2_vo_threads_weapons_storage();
		}
	}
}

pier2_wire_cross_vo_trig()
{
	t = getent("pier2_vo_trig_wire_mansion_seq","targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!isDefined(user.voEventFlags["wire_cross"]))
			user.voEventFlags["wire_cross"] = false;
			
		if(!user.voEventFlags["wire_cross"] && !user.currentlyTalking)
		{
			user.voEventFlags["wire_cross"] = true;
			user thread pier2_vo_threads_wire_cross();
		}
	}
}
/**********************VOICEOVER STUFF GOES DOWN HERE*******************************/

pier2_vo_threads_intro()
{
	self.currentlyTalking = true;
	self sayLine("pier2vo_john_some_transportation", &"PIER2VO_JOHN_SOME_TRANSPORTATION", 5);
	self sayLine("pier2vo_john_equipment_intact", &"PIER2VO_JOHN_EQUIPMENT_INTACT", 2.25);
	self holsterWeapons("holster");
	self sayLineSoundOnly("pier2vo_sfx_headset_on", 1.5);
	self thread holsterWeapons("retrieve");
	self sayLine("pier2vo_frt_testing_1_2_3", &"PIER2VO_FRITSCH_TESTING_CHECK_CHECK", 5.5);
	self sayLine("pier2vo_john_loud_and_clear", &"PIER2VO_JOHN_LOUD_AND_CLEAR_LT", 2);
	self sayLine("pier2vo_frt_aight_then_move_out", &"PIER2VO_FRITSCH_ALRIGHT_THEN_MOVE_OUT", 2);
	self sayLine("pier2vo_john_check_my_eyes", &"PIER2VO_JOHN_CHECK_MY_EYES_OUT_THERE", 4);
	self sayLine("pier2vo_frt_got_it_john", &"PIER2VO_FRITSCH_YOU_GOT_IT", 2);
	self sayLine("pier2vo_john_roger_that", &"PIER2VO_JOHN_ROGER_THAT", 1);
	self sayBlank();
	self.currentlyTalking = false;
}

pier2_vo_threads_ticket_office()
{
	self.currentlyTalking = true;
	wait 1; //realism lolz
	self sayLine("pier2vo_john_hm", &"PIER2VO_JOHN_HM", 1);
	self sayLine("pier2vo_john_where_is_everybody", &"PIER2VO_JOHN_WHERE_IS_EVERYBODY", 1.5);
	self sayBlank();
	self.currentlyTalking = false;
}

pier2_vo_threads_ship_docked()
{
	self.hasObjective5 = true;
	self objectiveDelete(4);
	self rezbarv2Notify(&"RZLPIER2_REZBAR_ESTABLISHING_LINK", "rezbarv2_notif_2", true);
	self rezbarv2Load(3, 0.5);
	self rezbarv2Notify(&"RZLPIER2_REZBAR_ESTABLISHED_LINK", "rezbarv2_notif_2", true);
	self.currentlyTalking = true;
	self sayLine("pier2vo_john_wolfsden_lonewolf", &"PIER2VO_JOHN_WOLFSDEN_LONEWOLF", 2.1);
	self sayLine("pier2vo_john_wolfsden_auth", &"PIER2VO_JOHN_WOLFSDEN_AUTH", 4.5);
	self sayLine("pier2vo_taylor_read_you_john", &"PIER2VO_TAYLOR_READ_YOU_JOHN", 2);
	self sayLine("pier2vo_john_full_system_sweep", &"PIER2VO_JOHN_FULL_SYSTEM_SWEEP", 4.75);
	self sayLine("pier2vo_taylor_we_are_on_it", &"PIER2VO_TAYLOR_WE_ARE_ON_IT", 5.5);
	self sayLine("pier2vo_john_understood", &"PIER2VO_JOHN_UNDERSTOOD", 1.5);
	self sayBlank();
	self.currentlyTalking = false;
	self rezbarv2NotifySimple(&"RZLPIER2_REZBAR_LINK_TERMINATED");
	wait 2;
	self objectiveAdd(5, "active", undefined, "objective", &"RZLPIER2_OBJ5_INV_SHIP");
	self objectiveAdd(6, "active", getent("pier2_ship_container_entrance_obj_org","targetname").origin, "objective", &"RZLPIER2_OBJ6_FIND_WAY_TO_BOARD_SHIP");
	self rezbarv2NotifySimple(&"RZLPIER2_OBJ_OBJECTIVES_UPDATED");
}
pier2_vo_threads_photographed()
{
	self.currentlyTalking = true;
	self sayLine("pier2vo_frt_good_work", &"PIER2VO_FRITSCH_GOOD_WORK", 1.5);
	self sayLine("pier2vo_john_more_shipments", &"PIER2VO_JOHN_MORE_SHIPMENTS", 4.5);
	self sayLine("pier2vo_taylor_understood", &"PIER2VO_TAYLOR_UNDERSTOOD", 3);
	self sayLine("pier2vo_john_roger_that", &"PIER2VO_JOHN_ROGER_THAT", 1);
	self sayBlank();
	self.currentlyTalking = false;
}
pier2_vo_threads_wire_cross()
{
	self.currentlyTalking = true;
	wait 1;
	self sayLine("pier2vo_taylor_john_you_read", &"PIER2VO_TAYLOR_JOHN_YOU_READ", 2);
	self sayLine("pier2vo_john_go_ahead", &"PIER2VO_JOHN_GO_AHEAD", 1.5);
	self sayLine("pier2vo_taylor_mansion_guarded_no_way_front", &"PIER2VO_TAYLOR_MANSION_GUARDED_NO_WAY_FRONT", 5);
	self sayLine("pier2vo_taylor_windows_covered_other_way_in", &"PIER2VO_TAYLOR_WINDOWS_COVERED_OTHER_WAY_IN", 4);
	self sayLine("pier2vo_john_ill_see_what_i_can_do", &"PIER2VO_JOHN_ILL_SEE_WHAT_I_CAN_DO", 1.5);
	self sayBlank();
	self.currentlyTalking = false;
}
pier2_vo_threads_weapons_storage()
{
	self.currentlyTalking = true;
	wait 0.5;
	self sayLine("pier2vo_john_jesus_freaking_arsenal_here", &"PIER2VO_JOHN_JESUS_FREAKING_ARSENAL_HERE", 4);
	self sayLine("pier2vo_frt_keep_moving", &"PIER2VO_FRITSCH_KEEP_MOVING", 1.5);
	self sayBlank();
	self.currentlyTalking = false;
}
pier2_vo_threads_walkway()
{
	isUserAlive = isAlive(self);
	self objectiveDelete(15);
	
	if(isUserAlive)
	{
		self.currentlyTalking = true;
		wait 0.25;
		self sayLine("pier2vo_frt_are_you_alright", &"PIER2VO_FRITSCH_ARE_YOU_ALRIGHT", 2);
		self sayLine("pier2vo_john_affirmative", &"PIER2VO_JOHN_AFFIRMATIVE", 1.5);
		self sayLine("pier2vo_frt_that_was_a_close_one", &"PIER2VO_FRITSCH_THAT_WAS_A_CLOSE_ONE", 2.5);
		self sayLine("pier2vo_john_a_lil_too_close", &"PIER2VO_JOHN_A_LIL_TOO_CLOSE", 1.75);
		self sayLine("pier2vo_taylor_be_careful_john", &"PIER2VO_TAYLOR_BE_CAREFUL_JOHN", 2);
		self sayLine("pier2vo_john_will_do", &"PIER2VO_JOHN_WILL_DO", 1.5);
		self sayBlank();
		self.currentlyTalking = false;
	}
}

pier2_vo_threads_bunker()
{
	self thread playUniqueMusicBit("ambience_music_bunker");
	self.currentlyTalking = true;
	wait 0.5;
	self sayLine("pier2vo_john_bunker", &"PIER2VO_JOHN_BUNKER", 2);
	self sayLine("pier2vo_john_fresh_air_in_here", &"PIER2VO_JOHN_FRESH_AIR_IN_HERE", 2.5);
	self sayLine("pier2vo_frt_stay_alert", &"PIER2VO_FRITSCH_STAY_ALERT", 1.5);
	self sayLine("pier2vo_john_agreed", &"PIER2VO_JOHN_AGREED", 1.5);
	self sayBlank();
	self.currentlyTalking = false;
}

pier2_vo_single_line_setup(trigName, eventFlagName, optionalWaitTime, lineAlias, lineLocStr, lineWait)
{
	t = getent(trigName,"targetname");
	
	while(1)
	{
		t waittill("trigger", user);
		if(!isDefined(user.voEventFlags[eventFlagName]))
			user.voEventFlags[eventFlagName] = false;
			
		if(!user.voEventFlags[eventFlagName] && !user.currentlyTalking)
		{
			user.voEventFlags[eventFlagName] = true;
			user thread pier2_vo_single_line_say(optionalWaitTime, lineAlias, lineLocStr, lineWait);
		}
	}
}

pier2_vo_single_line_say(optionalWaitTime, lineAlias, lineLocStr, lineWait)
{
	self.currentlyTalking = true;
	if(optionalWaitTime>0)
		wait optionalWaitTime;
	self sayLine(lineAlias, lineLocStr, lineWait);
	self sayBlank();
	self.currentlyTalking = false;
}